﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace USB16_Relays
{
    public partial class Form1 : Form
    {
        int buffLen = 0;
        byte[] inBuff = new byte[2];
        byte[] outBuff = new byte[2];
        byte[] tempBuff = new byte[10];
        string sendBuffer;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                serialPort.PortName = portsList.Text;
                serialPort.BaudRate = 9600;
                serialPort.Open();
                getRelays();
                statusLabel.Text = "Successfully opened port";
            }
            catch (Exception)
            {
                MessageBox.Show("Something went wrong. The device might be open or does not exist.", "Error");
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            foreach (string port in ports)
            {
                portsList.Items.Add(port);
            }
            portsList.SelectedIndex = 0;
            statusLabel.Text = "Select port and press Open";
        }

        private void setRelays(Int16 mask)
        {

        }

        private void getRelays()
        {
            try
            {
                serialPort.DiscardInBuffer();
                serialPort.Write("ask//");
                while (serialPort.BytesToRead < 2);
                buffLen = serialPort.BytesToRead;
                serialPort.Read(inBuff, 0, 2);
                UInt16 relaysStatus = (UInt16)((inBuff[0] << 8) + inBuff[1]);
                relayCheckBox1.Checked = ((relaysStatus & 0x8000) > 0) ? true : false;
                relayCheckBox2.Checked = ((relaysStatus & 0x4000) > 0) ? true : false;
                relayCheckBox3.Checked = ((relaysStatus & 0x2000) > 0) ? true : false;
                relayCheckBox4.Checked = ((relaysStatus & 0x1000) > 0) ? true : false;
                relayCheckBox5.Checked = ((relaysStatus & 0x0800) > 0) ? true : false;
                relayCheckBox6.Checked = ((relaysStatus & 0x0400) > 0) ? true : false;
                relayCheckBox7.Checked = ((relaysStatus & 0x0200) > 0) ? true : false;
                relayCheckBox8.Checked = ((relaysStatus & 0x0100) > 0) ? true : false;
                relayCheckBox9.Checked = ((relaysStatus & 0x0080) > 0) ? true : false;
                relayCheckBox10.Checked = ((relaysStatus & 0x0040) > 0) ? true : false;
                relayCheckBox11.Checked = ((relaysStatus & 0x0020) > 0) ? true : false;
                relayCheckBox12.Checked = ((relaysStatus & 0x0010) > 0) ? true : false;
                relayCheckBox13.Checked = ((relaysStatus & 0x0008) > 0) ? true : false;
                relayCheckBox14.Checked = ((relaysStatus & 0x0004) > 0) ? true : false;
                relayCheckBox15.Checked = ((relaysStatus & 0x0002) > 0) ? true : false;
                relayCheckBox16.Checked = ((relaysStatus & 0x0001) > 0) ? true : false;
            }
            catch (Exception ee)
            {
                MessageBox.Show(ee.Message);
            }
        }

        private void relayCheckBox1_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox1.Checked ? "01+//" : "01-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox2_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox2.Checked ? "02+//" : "02-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox3_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox3.Checked ? "03+//" : "03-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox4_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox4.Checked ? "04+//" : "04-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox5_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox5.Checked ? "05+//" : "05-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox6_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox6.Checked ? "06+//" : "06-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox7_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox7.Checked ? "07+//" : "07-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox8_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox8.Checked ? "08+//" : "08-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox9_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox9.Checked ? "09+//" : "09-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox10_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox10.Checked ? "10+//" : "10-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox11_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox11.Checked ? "11+//" : "11-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox12_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox12.Checked ? "12+//" : "12-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox13_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox13.Checked ? "13+//" : "13-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox14_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox14.Checked ? "14+//" : "14-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox15_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox15.Checked ? "15+//" : "15-//";
            setResetRelays(sendBuffer);
        }

        private void relayCheckBox16_CheckedChanged(object sender, EventArgs e)
        {
            sendBuffer = relayCheckBox16.Checked ? "16+//" : "16-//";
            setResetRelays(sendBuffer);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            setResetRelays("on//");
            getRelays();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            setResetRelays("off//");
            getRelays();
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            if (serialPort.IsOpen)
            {
                try
                {
                    serialPort.Close();
                    statusLabel.Text = "Successfully close port";
                }
                catch (Exception)
                {
                     statusLabel.Text="Could not close the port";
                }
            }
            else
            statusLabel.Text="There is no opened port";
        }

        private void setResetRelays(string command)
        {
            if (serialPort.IsOpen)
            {
                try
                {
                    serialPort.DiscardInBuffer();
                    serialPort.Write(command);
                    while (serialPort.BytesToRead < command.Length) ;
                    buffLen = serialPort.BytesToRead;
                    serialPort.Read(tempBuff, 0, buffLen);
                }
                catch (Exception ee)
                {
                    MessageBox.Show(ee.Message);
                }
            }
            else
                 statusLabel.Text="Open Port First";
        }
    }
}
